#include <time.h>
#include <stdio.h>
#include <string.h>

int main() {
    // Settings
    char CANSWER[20] = "CDDDADBCCB";
    char BANSWER[12][20] = {"5",           "3",  "EFDCIJHGBA", "3 12", "9",
                            "abcd-/+ef*-", "98", "0",          "7",    "4"}; // 答案
    int CNUM = 10, BNUM = 10;       // 题目数量
    int CCORRECT = 0, BCORRECT = 0; // 作答情况统计

    const char *p_time = "2024-06-21 10:00:00";
    struct tm tm_time = {};
    sscanf(p_time, "%4d-%2d-%2d %2d:%2d:%2d", &tm_time.tm_year, &tm_time.tm_mon,
           &tm_time.tm_mday, &tm_time.tm_hour, &tm_time.tm_min, &tm_time.tm_sec);
    tm_time.tm_year -= 1900, tm_time.tm_mon--, tm_time.tm_isdst = 0;
    time_t time_set = mktime(&tm_time);
    // time_set = 1654090200;
    time_t time_cur;
    time(&time_cur);
    fprintf(stderr, "Judger time settings: current:%lld, judge set at %lld\n", time_cur,
            time_set);
    if (time_cur < time_set) {
        printf("0");
        fprintf(stderr, "Your score will be judged after the end of this contest!");
    } else {
        FILE *IN = fopen("user_out", "r");
        for (int i = 1; i <= CNUM; i++) {
            char c = fgetc(IN);
            if (c == CANSWER[i - 1]) {
                CCORRECT++;
            } else {
                fprintf(stderr, "Q%d. Your answer %c, correct answer %c.\n", i, c,
                        CANSWER[i - 1]);
            }
        }
        {
            char c = fgetc(IN);
            while (c != '\n' && c != EOF)
                c = fgetc(IN);
        }
        for (int i = 1; i <= BNUM; i++) {
            char c[200];
            fgets(c, 200, IN);
            c[strcspn(c, "\n")] = '\0';
            c[strcspn(c, "\r")] = '\0';
            if (strcmp(c, BANSWER[i - 1]) == 0) {
                BCORRECT++;
            } else {
                char tmp[200];
                sprintf(tmp, "T%d_%s", i, BANSWER[i - 1]);
                if (i == 4)
                    sprintf(tmp, "T4_3 T4_12");
                if (strcmp(c, tmp) == 0) {
                    BCORRECT++;
                } else {
                    fprintf(stderr, "Q%d. Your answer \"%s\", correct answer \"%s\".\n",
                            i + 10, c, BANSWER[i - 1]);
                }
            }
        }
        printf("%d", (CCORRECT + 2 * BCORRECT) * 100 / (CNUM + 2 * BNUM));
        if (CNUM == CCORRECT && BNUM == BCORRECT) {
            fprintf(stderr, "All correct, well done.\n");
        }
    }
}
